varying vec3 V;
varying vec3 N;
varying float fogFactor;

void main()
{
	vec2 uv = gl_TexCoord[0].st;
	vec3 L = normalize(-V);
	vec3 E = normalize(-V);
	vec3 R = normalize(-reflect(L,N));
	
	// diffuse term with fake ambient occlusion
	float occlusion = 0.5 + 0.5*16.0*uv.x*uv.y*(1.0-uv.x)*(1.0-uv.y);
	vec4 diffuse = gl_Color * occlusion;
	diffuse *= max(dot(N,L), 0.0);

	// specular term
	vec4 specular = gl_Color;
	specular *= pow(max(dot(R,E),0.0), 50.0);
    const vec3 luminance = vec3(0.299, 0.587, 0.114);

	// write gamma corrected final color
	vec3 final = sqrt(diffuse + specular).rgb;    
    vec4 tmp = vec4(final.r,final.g,final.b,.7);
    
    gl_FragColor = mix(gl_Fog.color,tmp,fogFactor);
}